<?php
/******************************************************************************
 * WpTegaki - Function Define and WordPress Interface Inclide
 *****************************************************************************/

require('../../../wp-blog-header.php');
$wptegakiimg = & new WpTegakiImage();

/******************************************************************************
 * WpTegaki - Output True Type
 *  - 
 * 
 * @author		hiromasa
 * @version	0.1
 * 
 *****************************************************************************/
class WpTegakiImage {
	
	var $blog_charset;
	
	var $font_file;
	var $image_width;
	var $image_height;
	var $font_size;
	
	function WpTegakiImage() {
		
		global $wpdb;
		
		$this->blog_charset = get_settings('blog_charset');
		
		$this->font_file =  'aquafont.ttf';
		$this->image_width = 320;
		$this->image_height = 26;
		$this->font_size = 20;
		
		$ids = addslashes($_GET['tegaki_id']);
		list($id, $number) = split('-', $ids);
		
		if(!($post = &get_post($id))) return;
		
		$pattern = '/\[tegaki.*\](.*)\[\/tegaki\]/i';
		
		$content = $post->post_content;
		$content = mb_convert_encoding($content, "UTF-8", $this->blog_charset);
		
		$matches = '';
		
		preg_match_all($pattern, $content, $matches);
		$moji = $matches[1][$number];
		//$moji = mb_convert_encoding($content, "EUC-JP", "UTF-8");
		
		$this->writeImage($moji, '');
		
	}
	
	function writeImage($moji, $size) {
		
		$im = imagecreate($this->image_width, $this->image_height);
		
		$bgcolor = imagecolorallocate($im, 0xFF, 0xFF, 0xFF);
		$color = imagecolorallocate($im, 0x77, 0x77, 0x77);
		
		header("Content-type: image/png");
		
		imagettftext(
			$im, 
			$this->font_size,
			0, 0,
			$this->image_height - 6,
			$color,
			$this->font_file,
			$moji);
		
		imagepng($im);
		imagedestroy($im);
		
	}
	
}
?>
