<?php
/*
Plugin Name: wp-tegaki
Plugin URI: http://hiromasa.zone.ne.jp/blog/archives/598/
Description: Output Truetype font.
Author: hiromasa
Version: 0.1
Author URI: http://hiromasa.zone.ne.jp/blog/
*/

/*  Copyright 2005 hiromasa  (email : webmaster@hiromasa.zone.ne.jp)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/******************************************************************************
 * WpTegaki - function define
 *****************************************************************************/
if(class_exists('WpTegaki')) {
	
	$wptegaki = & new WpTegaki();
	add_filter('the_content', array(&$wptegaki, 'changeImage'));
	
}

/******************************************************************************
 * WpTegaki - WordPress Interface
 *  - 
 * 
 * @author		hiromasa
 * @version	0.1
 * 
 *****************************************************************************/
class WpTegaki {
	
	var $img_src;
	var $blog_charset;
	
	function WpTegaki() {
		
		$this->img_src  = get_settings('siteurl');
		$this->img_src .= '/wp-content/plugins/wp-tegaki/wp-tegaki-img.php';
		$this->blog_charset = get_settings('blog_charset');
		
	}
	
	function changeImage($content) {
		
		global $id;
		
		$pattern = '/\[tegaki.*\](.*)\[\/tegaki\]/i';
		$matches = '';
		$img_src = $this->img_src . "?tegaki_id=$id";
		
		$content
			= mb_convert_encoding($content, "UTF-8", $this->blog_charset);
		
		if(preg_match_all($pattern, $content, $matches)) {
			
			for ($i=0; $i< count($matches[0]); $i++) {
				
				$search_strings[$i]
					= '/' . preg_quote($matches[0][$i], '/') . '/';
				
				$moji = htmlspecialchars($matches[1][$i]);
				
				$img_src2 = $img_src . '-' . $i;
				$replace_string[$i]  = '<img src="' . $img_src2 . '"';
				$replace_string[$i] .= ' alt ="'. $moji . '" />';
				
			}
			$content
				= preg_replace($search_strings, $replace_string, $content);
			
		}
		
		$content
			= mb_convert_encoding($content, $this->blog_charset, "UTF-8");
		
		return $content;
		
	}
	
}
?>
